> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.makeswift.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.makeswift.com/_mcp/server.

# Create Site

POST https://api.makeswift.com/v2/sites
Content-Type: application/json

Creates a new site in a workspace.

Reference: https://docs.makeswift.com/developer/api-reference/rest/sites/create-site

## Authentication

- `x-api-key` header (required) — API key authentication. Accepts either: - App API key (e.g. sk_eczMHVBY9fV6GYFhvs53qcnxq7yptlXL3ABKOZtn6dQ) - Site API key (UUID format, e.g. 550e8400-e29b-41d4-a716-446655440000)

## Request

### Body (application/json)

This endpoint expects a CreateSiteV2RequestBodyDto.

- `workspaceId` (string, required) — The ID of the workspace that contains this site.
- `name` (string, required) — The site name.
- `hostOrigin` (string, optional) — The public URL where your site is hosted. This is the URL that Makeswift uses to render your site for editing.
- `defaultLocale` (string, optional, default: en-US) — The primary locale of this site.

## Response

### 201

- `object` (enum, required) — The type of the object
  - Allowed values: `site`
- `id` (string, required)
- `name` (string, required) — The site name.
- `hostOrigin` (string, required, nullable) — The public URL where your site is hosted. This is the URL that Makeswift uses to render your site for editing.
- `publicApiKey` (string, required) — The publishable API key that a host can use to get page and component data for rendering your site.
- `defaultLocale` (string, required) — The primary locale of this site.
- `localeManagementMode` (enum, required) — Controls whether locales are managed internally via the builder or externally via API.
  - Allowed values: `internal`, `external`
- `defaultLocalePathPrefix` (string, optional, nullable)

## Errors

### 400 Bad Request Error

- `object` (enum, required)
  - Allowed values: `error`
- `code` (enum, required)
  - Allowed values: `bad_request`
- `message` (string, required)

### 403 Forbidden Error

- `object` (enum, required)
  - Allowed values: `error`
- `code` (enum, required)
  - Allowed values: `forbidden`
- `message` (string, required)

## Examples

**Request**

```json
{
  "workspaceId": "string",
  "name": "Hearth Furniture Company"
}
```

**Response**

```json
{
  "object": "site",
  "id": "string",
  "name": "Hearth Furniture Company",
  "hostOrigin": "https://hearthfurniture.com",
  "publicApiKey": "string",
  "defaultLocale": "en-US",
  "localeManagementMode": "internal",
  "defaultLocalePathPrefix": "string"
}
```

**SDK Code**

```python
import requests

url = "https://api.makeswift.com/v2/sites"

payload = {
    "workspaceId": "string",
    "name": "Hearth Furniture Company"
}
headers = {
    "x-api-key": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.makeswift.com/v2/sites';
const options = {
  method: 'POST',
  headers: {'x-api-key': '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"workspaceId":"string","name":"Hearth Furniture Company"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.makeswift.com/v2/sites"

	payload := strings.NewReader("{\n  \"workspaceId\": \"string\",\n  \"name\": \"Hearth Furniture Company\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("x-api-key", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.makeswift.com/v2/sites")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-api-key"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"workspaceId\": \"string\",\n  \"name\": \"Hearth Furniture Company\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.makeswift.com/v2/sites")
  .header("x-api-key", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"workspaceId\": \"string\",\n  \"name\": \"Hearth Furniture Company\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.makeswift.com/v2/sites', [
  'body' => '{
  "workspaceId": "string",
  "name": "Hearth Furniture Company"
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'x-api-key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.makeswift.com/v2/sites");
var request = new RestRequest(Method.POST);
request.AddHeader("x-api-key", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"workspaceId\": \"string\",\n  \"name\": \"Hearth Furniture Company\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "x-api-key": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "workspaceId": "string",
  "name": "Hearth Furniture Company"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.makeswift.com/v2/sites")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```